local sti = require "sti"
require ('camera')
local bump = require 'bump.bump'

local world
sprClock = 0
acc = 10
gravity = 475
timerOn = true
timer = 0
infoText = "Use ARROW KEYS to move around\n jump to hide\npress T to toggle timer\nFind the compass"

player ={
	jH = -45,
	yV = 0,
	x = 160,
	y = 300,
	jumpAcc = 500,
	jumpMaxSpeed = 9.5,
	yacc = 0.9,
	yNew = 300,
	img = nil,
	maxSpeed = 1,

}


function love.load()
	love.graphics.setNewFont("assets/8bitOperatorPlusSC-Regular.ttf", 15)
	BGmusic = love.audio.newSource("assets/BG_Music.wav")
	Jump = love.audio.newSource("assets/jump.wav")
	BGmusic:setLooping(true)
	BGmusic:play()
	player.img = love.graphics.newImage('assets/sp1.png')
	world = bump.newWorld(32)
	map = sti("CastleMapA1.lua", { 'bump' })
	world:add(player, player.x, player.y, 28, 32)
	map:bump_init(world)
	love.graphics.setBackgroundColor( 50,50, 50)
-- adding the functions for adding the hitboxes for non square objects(the c stands for create)
	function cPlat(x,y,name)
		name = {
		x = x*32 + 2,
		y = y * 32
		}
		world:add(name, name.x, name.y, 28, 14)
	end
	function rLed (x,y,name)
		name = {
		x = x*32,
		y = y * 32
		}		
		world:add(name, name.x, name.y, 16, 8)
	end
	function lLed (x,y,name)
		name = {
		x = x*32+13,
		y = y * 32
		}
		world:add(name, name.x, name.y, 17, 8)
	end	
		--Adding all of the non-square platforms
	cPlat(0,43,p1)
	cPlat(0,56,p2)	
	cPlat(1,36,p3)
	cPlat(1,50,p4)
	cPlat(22,56,p5)
	cPlat(26,35,p6)
	cPlat(26,41,p7)
	cPlat(27,51,p8)
	cPlat(30,38,p9)
	cPlat(31,47,p10)
	cPlat(47,54,p11)
	cPlat(49,50,p12)
	cPlat(50,50,p13)
	cPlat(51,46,p14)
	cPlat(82,5,p15)
	cPlat(80,9,p16)
	cPlat(82,13,p17)
	cPlat(80,16,p18)
	cPlat(82,25,p19)
	cPlat(76,22,p20)
	cPlat(97,38,p21)
	cPlat(77,44,p22)
	cPlat(83,45,p23)
	cPlat(73,50,p24)
	cPlat(81,50,p25)
	cPlat(77,54,p26)
	cPlat(79,38,p26)
	cPlat(50,2,p27)
	lLed(21,4,L1)
	lLed(36,4,l2)
	lLed(44,1,l3)
	lLed(58,3,l4)
	rLed(15,4,r1)
	rLed(28,4,r2)
	rLed(30,6,r3)
	rLed(31,8,r4)
	rLed(39,4,r5)
	rLed(49,1,r6)
	rLed(52,4,r7)
	rLed(12,58,r8)
	--One coustome platform
	platform = {x=214,y=1824}
	world:add(platform, platform.x,platform.y,20,7)
end

function love.update(dt)
--Sprite updating
	sprClock = sprClock + dt
	if sprClock > 0.1666 then
		player.img = love.graphics.newImage('assets/sp2.png') 
		if sprClock > 0.3333 then
			player.img = love.graphics.newImage('assets/sp3.png')
			if sprClock > 0.5 then
				player.img = love.graphics.newImage('assets/sp4.png')
				if sprClock > 0.6666 then
					player.img = love.graphics.newImage('assets/sp5.png')
					if sprClock > 0.8333 then
						player.img = love.graphics.newImage('assets/sp6.png')
						if sprClock >= 1 then
							player.img = love.graphics.newImage('assets/sp1.png')
							sprClock = 0
						end
					end	
				end			
			end
		end
	end
--End Sprite updating Section

--timer things
	timer = timer + dt
	if love.keyboard.isDown('t') then
		timerOn = false
	end

--Updating the Player's Y volocity
	player.yV = player.yV * player.yacc	
	player.y = player.y + player.yV + gravity * dt
--The decreasing value makes the game go back to 0  yV really slowly so I have it jump there a little quicker
	if player.yV > -0.1 then
		player.yV = 0
	end
--Checking if the player is pushing a button that way we can move the character, the jumping action fails if they aren't grounded	
	if love.keyboard.isDown('up', 'w') and not player.nGounded then
	infoText = ""
	Jump:play()
	player.yV = player.jH
	end
	if love.keyboard.isDown('left', 'a') then
		player.x = player.x - 350 * dt
	elseif love.keyboard.isDown('right','d') then
		player.x = player.x + 350 *dt
	end	
--If the player wants to quit they can hit the ESCAPE button
	if love.keyboard.isDown('escape') then
		love.event.push('quit')
	end
--Conditionals checking if the player is grounded	
	player.yNew = player.y
	player.x, player.y, collisions = world:move(player, player.x, player.y)		
	if player.y == player.yNew then
		player.nGounded = true
	elseif player.y ~= player.yNew then
		player.nGounded = false
	end
	
--winning conditionals
	if player.x > 2336 and player.x < 2464 and player.y < 1120 and player.y > 992  then
		infoText = "You found the Magic\nCompass, Great Job"
		player.jH = -1000
		gravity = 2000
	end	
-- Game Over Conditionals
	if player.y > 2000 then
		love.graphics.setColor(255,255,255)
		infoText = "GAME OVER \n \n Press ESC to Quit \n \n Press R to restart"
		love.graphics.setColor(255,255,255)
	end

	if love.keyboard.isDown('r') then
		infoText = ''
		world:remove(player)
		player.x = 160
		player.y = 300
		world:add(player, player.x, player.y, 28, 32)
		map:update(dt)
	else 	
		camera:setPosition(player.x - love.graphics.getWidth() / 2, player.y - love.graphics.getHeight() / 2)
		map:update(dt)
	end
end

function love.draw(dt)
	camera:set()
	map:draw(-camera._x, -camera._y)
	love.graphics.setColor(0,30,100)
	if timerOn == true then
		love.graphics.print(timer, player.x -365, player.y-275)
	end
	if infoText == "GAME OVER \n \n Press ESC to Quit \n \n Press R to restart" then
		love.graphics.setColor(255,255,255)
		love.graphics.print(infoText, player.x, player.y + 50)
	elseif infoText == "You found the Magic\nCompass, Great Job" then
		love.graphics.setColor(255,255,255)
		love.graphics.print(infoText, player.x+30, player.y + 75)		
	else
		love.graphics.print(infoText, player.x, player.y + 50)
	end
	love.graphics.setColor(255,255,255)
	love.graphics.draw(player.img, player.x, player.y)	
	camera:unset()
end